=== debian/changelog ===
fastdds (2.7.1+ds-1~bpo11+1) bullseye-backports; urgency=medium

  * Unapply the tao-pegtl 3.x compatibility patch

 -- Bastian Germann <bage@debian.org>  Tue, 25 Oct 2022 19:53:28 +0200

fastdds (2.7.1+ds-1) unstable; urgency=medium

  * New upstream version 2.7.1+ds

 -- Timo Röhling <roehling@debian.org>  Sat, 30 Jul 2022 20:40:50 +0200

fastdds (2.7.0+ds-2) unstable; urgency=medium

  * Upload to unstable.

 -- Timo Röhling <roehling@debian.org>  Sat, 09 Jul 2022 20:24:35 +0200

fastdds (2.7.0+ds-1) experimental; urgency=medium

  * New upstream version 2.7.0+ds
  * Refresh patches
    - Drop Fix-FTBFS-with-GCC-12.patch (merged upstream)
  * SONAME bump: libfastrtps2.7

 -- Timo Röhling <roehling@debian.org>  Thu, 07 Jul 2022 23:22:25 +0200

fastdds (2.6.1+ds-2) unstable; urgency=medium

  * Fix FTBFS with GCC-12

 -- Timo Röhling <roehling@debian.org>  Thu, 16 Jun 2022 20:45:17 +0200

fastdds (2.6.1+ds-1) unstable; urgency=medium

  * New upstream version 2.6.1+ds
  * Bump Standards-Version to 4.6.1

 -- Timo Röhling <roehling@debian.org>  Mon, 13 Jun 2022 20:25:02 +0200

fastdds (2.6.0+ds-3) unstable; urgency=medium

  * Fix compatibility with tao-pegtl 3.x (Closes: #1009443)
  * Fix build with "nodoc" profile

 -- Timo Röhling <roehling@debian.org>  Tue, 12 Apr 2022 21:54:33 +0200

fastdds (2.6.0+ds-2) unstable; urgency=medium

  * Upload to unstable

 -- Timo Röhling <roehling@debian.org>  Wed, 23 Mar 2022 09:20:14 +0100

fastdds (2.6.0+ds-1) experimental; urgency=medium

  * New upstream version 2.6.0+ds
  * Bump SONAME to 2.6

 -- Timo Röhling <roehling@debian.org>  Sun, 20 Mar 2022 00:04:39 +0100

fastdds (2.5.1+ds-1) unstable; urgency=medium

  * New upstream version 2.5.1+ds

 -- Timo Röhling <roehling@debian.org>  Wed, 02 Mar 2022 10:19:55 +0100
